// programme de Frederic LETELLIER-COHEN

/////////////////////////////////////////////
// Envoyer vers l'appareil
int TPG300::send_rs232(QString la_commande)
{
  if(port == NULL)
  {
    // port serie inexistant
    thread.etat = 2;
    return -1;        
  }

  QByteArray commandeByte = la_commande.toAscii();
  port->write(commandeByte);

  port->flush();

  return 0; // 0 = tout va bien et -1 = probleme
}

/////////////////////////////////////////////
// Envoyer vers l'appareil
int TPG300::send_rs232_bytearray(char *la_commande, int nb)
{
  if(port == NULL)
  {
    // port serie inexistant
    thread.etat = 2;
    return -1;        
  }

  port->write(la_commande, nb);
  port->flush();

  return 0; // 0 = tout va bien et -1 = probleme
}

/////////////////////////////////////////////
// Recevoir de l'appareil
QString TPG300::receive_rs232(void)
{
  if(port == NULL)
  {
    // port serie inexistant
    thread.etat = 2;
    QString valeur_retour = "-1"; // Il y a un probleme
    return valeur_retour;        
  }

  int test = 0; // 0 = rien a recuperer
  for(int xyz = 0 ; xyz < 8; xyz++)
  {
    // on regarde s'il y a quelque chose a recuperer
//    if( port->size() == 0 && port->atEnd() == 0)
    if( port->size() == 0)
    {
      // on laise un delai pour voir si on ne recoit vraiment rien
      // Sleep(10); // 10 ms d'attente
      QEventLoop evtLoop;
      QTimer::singleShot(20, &evtLoop, SLOT(quit())); // 10 ms d'attente
      evtLoop.exec();
    }
    else
    {
      test = 1; // 1 = quelque chose a recuperer
      break;
    }
  }

  if( test == 0) 
  {
    // aucune donnee a lire
    return "-2";
  }


  // lecture d'une ligne
  char tableau[300];
  for(int i=0 ; i<200; i++)
    tableau[i] = '\0';
  port->readLine ( tableau, 200);  
  if (tableau[0] == '\0') // pas bon
  {
    // lecture ligne bizarre
    return "-2";
  }

  QString la_commande = tableau;

  return la_commande; 
}

/////////////////////////////////////////////
// Recevoir de l'appareil
void TPG300::receive_rs232_data(char *reception)
{
  if(port == NULL)
  {
    // port serie inexistant
    thread.etat = 2;
    return ;        
  }

  int test = 0; // 0 = rien a recuperer
  for(int xyz = 0 ; xyz < 8; xyz++)
  {
    // on regarde s'il y a quelque chose a recuperer
    if( port->size() == 0)
    {
      // on laise un delai pour voir si on ne recoit vraiment rien
      // Sleep(10); // 10 ms d'attente
      QEventLoop evtLoop;
      QTimer::singleShot(20, &evtLoop, SLOT(quit())); // 10 ms d'attente
      evtLoop.exec();
    }
    else
    {
      test = 1; // 1 = quelque chose a recuperer
      break;
    }
  }

  if( test == 0) 
  {
    // aucune donnee a lire
    return;
  }


  // on attend 20 ms
  QEventLoop evtLoop;
  QTimer::singleShot(20, &evtLoop, SLOT(quit())); // 20 ms d'attente
  evtLoop.exec();

  // lecture d'une ligne
  for(int i=0 ; i<200; i++)
    reception[i] = '\0';
  port->read ( reception, 200);  

  return ; 
}


/////////////////////////////////////////////
// Recevoir de l'appareil
void TPG300::vider_rs232(void)
{
  if(port == NULL)
    return;        

  if( port->size() == 0 && port->atEnd() == 0)
     return;

  // lecture d'une ligne
  char tableau[300];
  port->readLine ( tableau, 200);  

  return;
}
