// programme de Frederic LETELLIER-COHEN

#ifndef TPG300_H
#define TPG300_H

#include <QWidget>
#include <QtGui>

#include <qextserialport.h> // gestion des connexions RS232

#include "ui_tpg300.h" // interface graphique
#include "fenetre_rs232.h" // fenetre de configuration RS232
#include "fenetre_parametres.h" // fenetre de configuration de la mesure
#include "threadtpg300.h" // gestion du thread pour les mesures

class TPG300 : public QMainWindow
{
  Q_OBJECT

// variables et fonctions
public:
  TPG300(QWidget *parent = 0); // constructeur

  Ui::TPG300 ui; // interface graphique principale
  RS232 fenetre_rs232; // fenetre pour configurer la connexion RS232
  PARAMETRES fenetre_parametres; // fenetre pour configurer la mesure

  QextSerialPort *port; // sert a communiquer par le port serie

  RenderThread thread; // le thread qui lit les donnees de mesure

  // envoi et reception
  int send_rs232(QString la_commande); // envoyer vers l'appareil
  int send_rs232_bytearray(char *la_commande, int nb);
  QString receive_rs232(void); // recevoir une ligne de l'appareil
  void receive_rs232_data(char *reception); // recevoir une ligne de l'appareil
  void vider_rs232(void); // recevoir une ligne de l'appareil
  void mesure(void); // On realise une mesure des pressions

  // les fonctions de dialogue
  QString getpress(QString identifiant); // TPG300 Get Press
  QString gettension(void); // TPG300 Get Press
  QString getcourant(void); // TPG300 Get Press
  QString getpuissance(void); // TPG300 Get Press
  void getversion(void); // Demande de la version de l'appareil

  QString nom_file; // nom du fichier de stockage des donnees
  QDateTime date_init; // heure de debut
  int nb_cycles; // nombre de cycles de mesures

  QString get_pressa1; // U
  QString get_pressb1; // I
  QString get_pressa2; // P

  QString conversion3f(int valeur); // [0 - 2]
  QString conversion40(int valeur); // [3 - 8]
  QString conversion41(int valeur); // [9 - 32]
  QString conversion42(int valeur); // [33 - 128]
  QString conversion43(int valeur1,int valeur2); // [129 - 513]
  QString conversion44(int valeur1, int valeur2); // [514 - 800]



// les elements du UI
public slots:
  void on_pushButton_1_1_clicked();  // configuration RS232
  void on_pushButton_1_2_clicked();  // configuration paramtres
  void on_pushButton_1_3_clicked();  // connexion a l'appareil

};

#endif
